package be.iminds.ilabt.jfed.espec;

import org.testng.annotations.Test;

import java.util.Arrays;

import static org.testng.Assert.assertFalse;
import static org.testng.Assert.assertTrue;

public class ESpecLogicTest {

    @Test
    public void testMustRunOnBecauseOfNodesA() throws Exception {
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "test2"),
                "test",
                Arrays.asList("nogroup")
        ));
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "test2"),
                "test2",
                Arrays.asList("nogroup")
        ));
        assertFalse(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "test2"),
                "test3",
                Arrays.asList("nogroup")
        ));
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "test2"),
                "test",
                null
        ));
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "test2"),
                "test2",
                null
        ));
        assertFalse(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "test2"),
                "test3",
                null
        ));
    }

    @Test
    public void testMustRunOnBecauseOfNodesB() throws Exception {
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "ansible_group:testgroup"),
                "test",
                Arrays.asList("nogroup")
        ));
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "ansible_group:testgroup"),
                "test",
                Arrays.asList("testgroup")
        ));
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "ansible_group:testgroup"),
                "test",
                null
        ));
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "ansible_group:testgroup"),
                "test2",
                Arrays.asList("testgroup")
        ));
        assertFalse(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "ansible_group:testgroup"),
                "test3",
                Arrays.asList("nogroup")
        ));
        assertFalse(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "ansible_group:testgroup"),
                "test3",
                null
        ));
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "ansible_group:testgroup1"),
                "test2",
                Arrays.asList("testgroup1","testgroup2")
        ));
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "ansible_group:testgroup2"),
                "test2",
                Arrays.asList("testgroup1","testgroup2")
        ));
        assertFalse(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("test", "ansible_group:testgroup"),
                "test3",
                Arrays.asList("testgroup1","testgroup2")
        ));
    }

    @Test
    public void testMustRunOnBecauseOfNodesC() throws Exception {
        assertFalse(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("ansible_group:testgroup"),
                "test",
                Arrays.asList("nogroup")
        ));
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("ansible_group:testgroup"),
                "test",
                Arrays.asList("testgroup")
        ));
        assertFalse(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("ansible_group:testgroup"),
                "test",
                null
        ));
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("ansible_group:testgroup"),
                "test2",
                Arrays.asList("testgroup")
        ));
        assertFalse(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("ansible_group:testgroup"),
                "test3",
                Arrays.asList("nogroup")
        ));
        assertFalse(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("ansible_group:testgroup"),
                "test3",
                null
        ));
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("ansible_group:testgroup1"),
                "test2",
                Arrays.asList("testgroup1","testgroup2")
        ));
        assertTrue(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("ansible_group:testgroup2"),
                "test2",
                Arrays.asList("testgroup1","testgroup2")
        ));
        assertFalse(ESpecLogic.mustRunOnBecauseOfNodes(
                Arrays.asList("ansible_group:testgroup"),
                "test3",
                Arrays.asList("testgroup1","testgroup2")
        ));
    }
}